
    
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */

//-----------------------
#define PORT_OUT			PORTD
#define DDR_OUT				DDRD
#define OUT_TRIAC			_BV(3)
volatile uint8_t power;

ISR(TIMER2_COMP_vect){//   
	PORT_OUT|=OUT_TRIAC;
	_delay_us(20);
	PORT_OUT&=~OUT_TRIAC;
}

ISR(SIG_INTERRUPT0)//   .
{
	SFIOR|=_BV(PSR2);// Bit 0  PSR10: Prescaler Reset Timer/Counter1 and Timer/Counter0
	TCNT2=0;
	//OCR2=power;
}

static void avr_init(void)
{
	TCCR0=_BV(CS00);
	TCCR1B=(1<<CS10)|(1<<WGM12);// ctc mode
	
	MCUCR=(1<<ISC01)|(0<<ISC00);//1 1 The rising edge  //1 0 The falling edge of INT1 generates an interrupt request.
	GICR=_BV(INT0);//External Interrupt Request 0 Enable
	
	//DDRZN=BITZN|SEG_GH;//    gh  
	//DDRLED=0xFF;	

	//DDR_VLAG|=OUT_VLAG;
	
	//DDR_OUT=OUT_PIN;
	
	TIMSK=_BV(OCIE2);
	OCR1A=4000;// 1 
	OCR2=220;//156 ~= 10mSek, 220 -   , TCNT2     ,    ISR(SIG_INTERRUPT0)
	TCCR2=(1<<CS22)|(1<<CS21)|(0<<CS20);//  256
	
	sei();

    return;
}


void main(void)
{
uint16_t time=0;
avr_init();

OCR2=50;

while(1)
{
if (TIFR & _BV(OCF1A)) // 0.001 sek
	{
	TIFR = _BV(OCF1A);
	if(++time>=500)
		{
		time=0;
		if (++power>=140) power=0;
		}
	}

}
}



	
    